package w6.ex1.deadlock.ex;

public class PersonSyn extends Thread {
	private String name;
	private PersonSyn whomToAsk;

	public PersonSyn(String name) {
		this.name = name;
	}

	public void setWhomToAsk(PersonSyn whomToAsk) {
		this.whomToAsk = whomToAsk;
	}

	public String toString() {
		return name;
	}

	private synchronized void getAQuestionFrom(PersonSyn p) {
		try {
			System.out.println(this + " says: I got a question from " + p);
			// Think a while before answering...
			Thread.sleep(50);
			p.getAnAnswerFrom(this);
		} catch (InterruptedException e) {
			Thread.currentThread().interrupt();
		}
	}

	private synchronized void getAnAnswerFrom(PersonSyn p) {
		System.out.println(this + " says: I got an answer from " + p);
	}

	public void run() {
		whomToAsk.getAQuestionFrom(this);
	}

	public static void main(String[] args) {
		PersonSyn p1 = new PersonSyn("Pelle");
		PersonSyn p2 = new PersonSyn("Emil");
		p1.setWhomToAsk(p2);
		p2.setWhomToAsk(p1);
		p1.start();
		p2.start();
	}
}
