package w6.ex1.deadlock.ex;

public class Person extends Thread {
	private String name;
	private Person whomToAsk;

	public Person(String name) {
		this.name = name;
	}

	public void setWhomToAsk(Person whomToAsk) {
		this.whomToAsk = whomToAsk;
	}

	public String toString() {
		return name;
	}

	private void getAQuestionFrom(Person p) {
		try {
			System.out.println(this + " says: I got a question from " + p);
			// Think a while before answering...
			Thread.sleep(50);
			p.getAnAnswerFrom(this);
		} catch (InterruptedException e) {
			Thread.currentThread().interrupt();
		}
	}

	private void getAnAnswerFrom(Person p) {
		System.out.println(this + " says: I got an answer from " + p);
	}

	public void run() {
		whomToAsk.getAQuestionFrom(this);
	}

	public static void main(String[] args) {
		Person p1 = new Person("Pelle");
		Person p2 = new Person("Emil");
		p2.setWhomToAsk(p1);
		p1.setWhomToAsk(p2);
		p1.start();
		p2.start();
	}
}